Subject: Re: [PATCH v7] git-prompt: make colourization consistent

From: Junio C Hamano <[email-masked]>
Date: Thu, 09 Jun 2022 11:29:25 -0700

Joakim Petersen <[email-masked]> writes:

> On 09/06/2022 11:03, SZEDER Gábor wrote:
>> This patch seems to break colorization when __git_ps1() is invoked
>> from $PROMPT_COMMAND:
>>    ~/src/git (master)$ echo $PROMPT_COMMAND
>> __git_ps1 "\[\e]0;\w - Terminal\a\e[01;32m\]\h\[\e[01;34m\] \w" "\[\e[01;34m\]\$\[\e[00m\] " " \[\e[01;34m\](%s\[\e[01;34m\])"
>>    ~/src/git (master)$ git checkout 9470605a1b
>>    HEAD is now at 9470605a1b git-prompt: make colourization consistent
>>    ~/src/git ((9470605a1b...))$ source contrib/completion/git-prompt.sh
>>    ~/src/git (\[\e[31m\](9470605a1b...)\[\e[0m\])$ # uh-oh
>>    ~/src/git (\[\e[31m\](9470605a1b...)\[\e[0m\])$ git checkout 9470605a1b^
>>    Previous HEAD position was 9470605a1b git-prompt: make colourization consistent
>>    HEAD is now at 2668e3608e Sixth batch
>>    ~/src/git (\[\e[31m\](2668e3608e...)\[\e[0m\])$ source contrib/completion/git-prompt.sh
>>    ~/src/git ((2668e3608e...))$ # Looks good.
>> 
>
> While I did test this on my own prompt for v6 (which is identical to v7
> in terms of code) and not see any breakage, I have the same issue with
> v7. Maybe I forgot to re-source the changed git-prompt.sh. Either way,
> The issue stems from $b being wrapped in $__git_ps1_branch_name and then
> back into itself after colouring. Moving this wrapping to before colour
> is applied fixes this. I will submit a v8 shortly.

As the topic is already in 'next' (and presumably that is how SZEDER
noticed the breakage), please make it an incremental fix-up.

Thanks.